exercise_04_16: exercise_04_16.o | .gitignore
	g++ $^ -o $@ 
exercise_04_16.ii: exercise_04_16.cpp
	g++ -E $^ -o $@
exercise_04_16.s: exercise_04_16.ii
	g++ -S $^ -o $@
exercise_04_16.o: exercise_04_16.s
	g++ -c $^ -o $@
.gitignore:
	echo "exercise_04_16" > $@
clean:
	rm -rf *.ii *.s *.o exercise_04_16 .gitignore *.out debug
test1: exercise_04_16 
	@./exercise_04_16 < test1.in > test1.out
	@diff test1.out test1.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: exercise_04_16.ii exercise_04_16.s
.SECONDARY: exercise_04_16.ii exercise_04_16.s

dbg: debug/exercise_04_16
debug/exercise_04_16: debug/exercise_04_16.o
	g++     -Wall -Wextra -Werror -g3 debug/exercise_04_16.o     -o debug/DecisionMaking
debug/exercise_04_16.o: debug/exercise_04_16.s
	g++ -c -Wall -Wextra -Werror -g3 debug/exercise_04_16.s     -o debug/exercise_04_16.o
debug/exercise_04_16.s: debug/exercise_04_16.ii
	g++ -S -Wall -Wextra -Werror -g3 debug/exercise_04_16.ii     -o debug/exercise_04_16.s
debug/exercise_04_16.ii: exercise_04_16.cpp
	g++ -E -Wall -Wextra -Werror -g3            exercise_04_16.cpp -o debug/exercise_04_16.ii
debug/exercise_04_16.ii: | debug
debug:
	mkdir -p debug

